Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -108,4 +108,8 @@
 }
 
+void CommandLineDialog::queryRandomNumberDistribution_Parameters(const char* title, string _description){
+  registerQuery(new RandomNumberDistribution_ParametersCommandLineQuery(title, _description));
+}
+
 /************************** Query Infrastructure ************************/
 /*       ---> shifted to folder Query                                   */
Index: src/UIElements/CommandLineUI/CommandLineDialog.hpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -51,7 +51,9 @@
   virtual void queryElements(const char*, std::string = "");
   virtual void queryFile(const char*, std::string = "");
-
+  virtual void queryRandomNumberDistribution_Parameters(const char*, std::string = "");
 protected:
-  // specialized stuff for text queries
+  // specialized stuff for command line queries
+  // all placed into Query/CommandLineQuery.hpp
+  // !please adhere to alphabetical ordering!
   class AtomCommandLineQuery;
   class AtomsCommandLineQuery;
@@ -72,4 +74,5 @@
   class VectorCommandLineQuery;
   class VectorsCommandLineQuery;
+  class RandomNumberDistribution_ParametersCommandLineQuery;
 };
 
Index: src/UIElements/CommandLineUI/CommandLineParser.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -326,4 +326,13 @@
         ;
       break;
+    case TypeEnumContainer::RandomNumberDistribution_ParametersType:
+      OptionList->add_options()
+        (currentOption->getKeyAndShortForm().c_str(),
+            currentOption->hasDefaultValue() ?
+                  po::value < std::string >()->default_value(boost::lexical_cast< std::string >(currentOption->getDefaultValue().c_str())) :
+                  po::value < std::string >(),
+                  currentOption->getDescription().c_str())
+        ;
+      break;
   }
 }
Index: src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp
===================================================================
--- src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -143,3 +143,10 @@
 };
 
+class CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery : public Dialog::RandomNumberDistribution_ParametersQuery {
+public:
+  RandomNumberDistribution_ParametersCommandLineQuery(std::string title, std::string _description = "");
+  virtual ~RandomNumberDistribution_ParametersCommandLineQuery();
+  virtual bool handle();
+};
+
 #endif /* COMMANDLINEQUERY_HPP_ */
Index: src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
+++ src/UIElements/CommandLineUI/Query/RandomNumberDistribution_ParametersCommandLineQuery.cpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -0,0 +1,52 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * RandomNumberDistribution_ParametersCommandLineQuery.cpp
+ *
+ *  Created on: Jan 06, 2011
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+#include <sstream>
+#include <string>
+
+#include "CommandLineUI/Query/CommandLineQuery.hpp"
+#include "CommandLineUI/CommandLineParser.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+#include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
+
+CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::RandomNumberDistribution_ParametersCommandLineQuery(string title, string _description) :
+    Dialog::RandomNumberDistribution_ParametersQuery(title, _description)
+{}
+
+CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::~RandomNumberDistribution_ParametersCommandLineQuery() {}
+
+bool CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    std::string stringtext = CommandLineParser::getInstance().vm[getTitle()].as<std::string>();
+    std::stringstream text(stringtext);
+//    DoLog(1) && (Log() << Verbose(1) << "Parameter set from CommandLine is '"
+//        << text.str() << "'" << std::endl);
+    text >> tmp;
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing RandomNumberDistribution_Parameters for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/TypeEnumContainer.cpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -36,4 +36,5 @@
 #include "element.hpp"
 #include "molecule.hpp"
+#include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
 
 /** Constructor for class TypeEnumContainer.
@@ -63,4 +64,5 @@
   TypeEnumMap[&typeid(const element *)] = ElementType;
   TypeEnumMap[&typeid(std::vector<const element *>)] = ListOfElementsType;
+  TypeEnumMap[&typeid(RandomNumberDistribution_Parameters)] = RandomNumberDistribution_ParametersType;
 
   // for debugging: list all stored types
Index: src/UIElements/CommandLineUI/TypeEnumContainer.hpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision 0275ad195a931bec57fdd26321f927b08c267597)
@@ -44,5 +44,6 @@
         ListOfMoleculesType,
         ElementType,
-        ListOfElementsType
+        ListOfElementsType,
+        RandomNumberDistribution_ParametersType
   };
 