Index: src/Parser/TremoloAtomInfoContainer.cpp
===================================================================
--- src/Parser/TremoloAtomInfoContainer.cpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/TremoloAtomInfoContainer.cpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -32,5 +32,5 @@
   imprData("-"),
   GroupMeasureTypeNo("0"),
-  Type("-"),
+  type("-"),
   extType("-"),
   name("-"),
@@ -63,6 +63,6 @@
       GroupMeasureTypeNo = value;
       break;
-    case TremoloKey::Type :
-      Type = value;
+    case TremoloKey::type :
+      type = value;
       break;
     case TremoloKey::extType :
@@ -121,6 +121,6 @@
     case TremoloKey::GroupMeasureTypeNo :
       return GroupMeasureTypeNo;
-    case TremoloKey::Type :
-      return Type;
+    case TremoloKey::type :
+      return type;
     case TremoloKey::extType :
       return extType;
@@ -161,5 +161,5 @@
   out << info.get(TremoloKey::imprData) << "\t";
   out << info.get(TremoloKey::GroupMeasureTypeNo) << "\t";
-  out << info.get(TremoloKey::Type) << "\t";
+  out << info.get(TremoloKey::type) << "\t";
   out << info.get(TremoloKey::extType) << "\t";
   out << info.get(TremoloKey::name) << "\t";
Index: src/Parser/TremoloAtomInfoContainer.hpp
===================================================================
--- src/Parser/TremoloAtomInfoContainer.hpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/TremoloAtomInfoContainer.hpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -32,5 +32,5 @@
   std::string imprData;
   std::string GroupMeasureTypeNo;
-  std::string Type;
+  std::string type;
   std::string extType;
   std::string name;
Index: src/Parser/TremoloKey.hpp
===================================================================
--- src/Parser/TremoloKey.hpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/TremoloKey.hpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -30,5 +30,5 @@
     imprData,
     GroupMeasureTypeNo,
-    Type,
+    type,
     extType,
     name,
Index: src/Parser/TremoloParser.cpp
===================================================================
--- src/Parser/TremoloParser.cpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/TremoloParser.cpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -54,5 +54,5 @@
   knownKeys["imprData"] = TremoloKey::imprData;
   knownKeys["GroupMeasureTypeNo"] = TremoloKey::GroupMeasureTypeNo;
-  knownKeys["Type"] = TremoloKey::Type;
+  knownKeys["type"] = TremoloKey::type;
   knownKeys["extType"] = TremoloKey::extType;
   knownKeys["name"] = TremoloKey::name;
@@ -196,5 +196,5 @@
         *file << currentAtom->getAtomicVelocity()[2] << "\t";
         break;
-      case TremoloKey::Type :
+      case TremoloKey::type :
         if (additionalAtomData.count(currentAtom->getId())) {
           if (additionalAtomData[currentAtom->getId()].get(currentField) != "-") {
@@ -361,5 +361,5 @@
         newAtom->setAtomicVelocity(tempVector);
         break;
-      case TremoloKey::Type :
+      case TremoloKey::type :
       {
         ASSERT(tok_iter != tokens.end(), "TremoloParser::readAtomDataLine() - no value for "+keyName+"!");
Index: src/Parser/TremoloParser.hpp
===================================================================
--- src/Parser/TremoloParser.hpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/TremoloParser.hpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -53,5 +53,5 @@
 
   /**
-   * Map to associate the elements with stuff in "Type", e.g. OC2 -> O.
+   * Map to associate the elements with stuff in "type", e.g. OC2 -> O.
    */
   std::map<std::string, std::string> knownTypes;
Index: src/Parser/unittests/ParserTremoloUnitTest.cpp
===================================================================
--- src/Parser/unittests/ParserTremoloUnitTest.cpp	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ src/Parser/unittests/ParserTremoloUnitTest.cpp	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -46,21 +46,21 @@
 
 static string Tremolo_Atomdata1 = "\
-# ATOMDATA\tId\tname\tType\tx=3\n";
+# ATOMDATA\tId\tname\ttype\tx=3\n";
 static string Tremolo_Atomdata2 = "\
 #\n\
-#ATOMDATA Id name Type x=3\n\
+#ATOMDATA Id name type x=3\n\
 1 hydrogen H 3.0 4.5 0.1\n\
 \n";
 static string Tremolo_invalidkey = "\
 #\n\
-#ATOMDATA Id name foo Type x=3\n\
+#ATOMDATA Id name foo type x=3\n\
 \n\n";
 static string Tremolo_velocity = "\
 #\n\
-#ATOMDATA Id name Type u=3\n\
+#ATOMDATA Id name type u=3\n\
 1 hydrogen H 3.0 4.5 0.1\n\
 \n";
 static string Tremolo_neighbours = "#\n\
-#ATOMDATA Id Type neighbors=2\n\
+#ATOMDATA Id type neighbors=2\n\
 1 H 3 0\n\
 2 H 3 0\n\
@@ -68,5 +68,5 @@
 static string Tremolo_improper = "\
 #\n\
-#ATOMDATA Id Type imprData\n\
+#ATOMDATA Id type imprData\n\
 8 H 9-10\n\
 9 H 10-8,8-10\n\
@@ -74,10 +74,10 @@
 static string Tremolo_torsion = "\
 #\n\
-#ATOMDATA Id Type torsion\n\
+#ATOMDATA Id type torsion\n\
 8 H 9-10\n\
 9 H 10-8,8-10\n\
 10 O -\n";
 static string Tremolo_full = "\
-# ATOMDATA\tx=3\tu=3\tF\tstress\tId\tneighbors=5\timprData\tGroupMeasureTypeNo\tType\textType\tname\tresName\tchainID\tresSeq\toccupancy\ttempFactor\tsegID\tCharge\tcharge\tGrpTypeNo\ttorsion\n\
+# ATOMDATA\tx=3\tu=3\tF\tstress\tId\tneighbors=5\timprData\tGroupMeasureTypeNo\ttype\textType\tname\tresName\tchainID\tresSeq\toccupancy\ttempFactor\tsegID\tCharge\tcharge\tGrpTypeNo\ttorsion\n\
 0\t0\t0\t0\t0\t0\t0\t0\t1\t0\t0\t0\t0\t0\t-\t0\tH\t-\t-\t-\t0\t0\t0\t0\t0\t0\t0\t0\t-\t\n";
 
@@ -214,5 +214,5 @@
     atom* newAtom = World::getInstance().createAtom();
     newAtom->setType(1);
-    testParser->setFieldsForSave("x=3 u=3 F stress Id neighbors=5 imprData GroupMeasureTypeNo Type extType name resName chainID resSeq occupancy tempFactor segID Charge charge GrpTypeNo torsion");
+    testParser->setFieldsForSave("x=3 u=3 F stress Id neighbors=5 imprData GroupMeasureTypeNo type extType name resName chainID resSeq occupancy tempFactor segID Charge charge GrpTypeNo torsion");
     std::vector<atom *> atoms = World::getInstance().getAllAtoms();
     testParser->save(&output, atoms);
Index: tests/regression/Atoms/Add/post/test.data
===================================================================
--- tests/regression/Atoms/Add/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Atoms/Add/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	0	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	0	0	0	0	-	H	0	0	0	10	10	10	
Index: tests/regression/Filling/FillVoidWithMolecule/post/tensid.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/post/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/post/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	17.397	20.231	11.737	Na	0	0	0	0	1.000000e+00	
 2	S	SLES	1	16.282	18.88	14.208	S	3	4	5	6	1.330000e+00	
Index: tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/pre/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	17.397	20.231	11.737	Na	0	0	0	0	1.000000e+00	
 2	S	SLES	1	16.282	18.88	14.208	S	3	4	5	6	1.330000e+00	
Index: tests/regression/Filling/FillVoidWithMolecule/pre/water.data
===================================================================
--- tests/regression/Filling/FillVoidWithMolecule/pre/water.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Filling/FillVoidWithMolecule/pre/water.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	-	-	0	0.	0.	0.	O	2	3	0	0	0
 2	-	-	0	0.758602	0.	0.504284	H	1	0	0	0	0
Index: tests/regression/Molecules/Copy/post/tensid.data
===================================================================
--- tests/regression/Molecules/Copy/post/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Molecules/Copy/post/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1.000000e+00	
 2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.330000e+00	
Index: tests/regression/Molecules/Copy/pre/tensid.data
===================================================================
--- tests/regression/Molecules/Copy/pre/tensid.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Molecules/Copy/pre/tensid.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	resName	chainID	x=3	Type	neighbors=4	charge
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1.000000e+00	
 2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.330000e+00	
Index: tests/regression/Parser/Tremolo-Potentials/post/argon.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/post/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/post/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	Type	x=3
+# ATOMDATA	Id	name	type	x=3
 1	Ar1	Argon	4.72977	8	8	
 2	Ar2	Argon	7.3	8	8	
Index: tests/regression/Parser/Tremolo-Potentials/post/test.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	Ar	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	4.72977	8	8	
-0	0	0	0	2	Ar	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	7.3	8	8	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	Ar	0	0	0	4.72977	8	8	
+0	0	0	0	2	0	0	-	-	-	0	-	   1	0	0	0	-	Ar	0	0	0	7.3	8	8	
Index: tests/regression/Parser/Tremolo-Potentials/pre/argon.data
===================================================================
--- tests/regression/Parser/Tremolo-Potentials/pre/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo-Potentials/pre/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA Id name Type x=3
+# ATOMDATA Id name type x=3
 1	Ar1	Argon	4.72977074	8.	8.	
 2	Ar2	Argon	7.3		8.		8.		
Index: tests/regression/Parser/Tremolo/post/argon.data
===================================================================
--- tests/regression/Parser/Tremolo/post/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/post/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA	Id	name	Type	x=3
+# ATOMDATA	Id	name	type	x=3
 1	Ar1	Ar	4.72977	8	8	
 2	Ar2	Ar	7.3	8	8	
Index: tests/regression/Parser/Tremolo/post/test.data
===================================================================
--- tests/regression/Parser/Tremolo/post/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/post/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	H	0	0	0	10	10	10	
Index: tests/regression/Parser/Tremolo/pre/argon.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/argon.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/pre/argon.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,3 +1,3 @@
-# ATOMDATA Id name Type x=3
+# ATOMDATA Id name type x=3
 1	Ar1	Ar	4.72977074	8.	8.	
 ###2	3	4	5
Index: tests/regression/Parser/Tremolo/pre/test.data
===================================================================
--- tests/regression/Parser/Tremolo/pre/test.data	(revision 4217e768dc3bd03c7e60ad2a4aaf951c557eab5a)
+++ tests/regression/Parser/Tremolo/pre/test.data	(revision 305e7e066de5b54b2aeede90057a8e00faffd49c)
@@ -1,2 +1,2 @@
-# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	Type	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	u	x
-0	0	0	0	1	H	0	0	-	-	-	0	-	   1	0	0	0	-	0	0	0	10	10	10	
+# ATOMDATA	Charge	F	GroupMeasureTypeNo	GrpTypeNo	Id	chainID	charge	extType	imprData	name	neighbors	occupancy	resName	resSeq	segID	stress	tempFactor	torsion	type	u	x
+0	0	0	0	1	0	0	-	-	-	0	-	   1	0	0	0	-	H	0	0	0	10	10	10	